質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.63%

ラズパイで温湿度センサー(DHT11)をnode.jsで制御したい

受付中

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 2,211

rikissa_fusa

score 8

ラズパイを使って温湿度センサー(DHT11)から温度と湿度を得たいです。node.jsのライブラリを使って制御したいのですが、以下の様なエラーが出ます

module.js:356
  Module._extensions[extension](this, filename);
                               ^
Error: /home/pi/Desktop/PD/bcm2835-1.36/node_modules/node-dht-sensor/build/Release/node-dht-sensor.node: undefined symbol: node_module_register
    at Module.load (module.js:356:32)
    at Function.Module._load (module.js:312:12)
    at Module.require (module.js:364:17)
    at require (module.js:380:17)
    at Object.<anonymous> (/home/pi/Desktop/PD/bcm2835-1.36/testpd.js:1:79)
    at Module._compile (module.js:456:26)
    at Object.Module._extensions..js (module.js:474:10)
    at Module.load (module.js:356:32)
    at Function.Module._load (module.js:312:12)
    at Function.Module.runMain (module.js:497:10)

root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36# npm -v
1.4.9
root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36# node -v
v0.10.28

解決策を教えてください。
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

+1

Node.js のバージョンを v0.11.x 以上(できれば最新版のv0.12.z)にバージョンアップできませんか?

こちら の情報によれば、いまエラーの原因になっている node_module_register という 内部API は v0.11.11 になってNode.jsに追加されたそうなので、module.js から呼びだそうとしても v0.10.2 では見つからないようです。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2015/10/04 11:55

    nodeのバージョンをv0.12.7にして実行しましたが、動きませんでした。エラーもでませんでした。また、v0.11.11にして実行した場合、新たなエラーが出てしまいました。

    root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36/node_modules# ls
    node-dht-sensor test.js
    root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36/node_modules# nvm use v0.12.7
    Now using node v0.12.7 (npm v2.11.3)
    root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36/node_modules# node test.js
    ^C
    root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36/node_modules# nvm use v0.11.11
    Now using node v0.11.11 (npm v1.3.25)
    root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36/node_modules# node test.js
    node: symbol lookup error: /home/pi/Desktop/PD/bcm2835-1.36/node_modules/node-dht-sensor/build/Release/node-dht-sensor.node: undefined symbol: _ZN2v816FunctionTemplate3NewEPNS_7IsolateEPFvRKNS_20FunctionCallbackInfoINS_5ValueEEEENS_6HandleIS4_EENSA_INS_9SignatureEEEi
    root@raspberrypi:/home/pi/Desktop/PD/bcm2835-1.36/node_modules#

    キャンセル

  • 2015/10/05 10:06 編集

    「Raspberry Pi」なのですよね?
    「Raspberry Pi 2」ではありませんよね?

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.63%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る